##########################################
#
#   xmconvert - mtime <--> stime converter
#
##########################################

#########################
#
# initialize variables...
#
#########################
set xmcdir      /usr/local/bin
set xmclib      /usr/local/share/xmclock

set mtime       0
set stime       0

########################
#
# create all the bitmaps
#
########################
image create bitmap b1 -file "$xmclib/1.xbm"
image create bitmap b2 -file "$xmclib/2.xbm"
image create bitmap b3 -file "$xmclib/3.xbm"
image create bitmap b4 -file "$xmclib/4.xbm"
image create bitmap b5 -file "$xmclib/5.xbm"
image create bitmap b6 -file "$xmclib/6.xbm"
image create bitmap b7 -file "$xmclib/7.xbm"
image create bitmap b8 -file "$xmclib/8.xbm"
image create bitmap b9 -file "$xmclib/9.xbm"
image create bitmap b0 -file "$xmclib/0.xbm"
image create bitmap bc -file "$xmclib/c.xbm"
image create bitmap bd -file "$xmclib/d.xbm"

#########################################################
#
# proc change - this is where we come when we're clicked!
#
# all the action is right here.
#
#########################################################
proc change { element } {
    global mtime
    global stime

    set mos [ string index $element 0 ]
    set idx [ string index $element 1 ]

    #
    # The mtime changed...
    #
    if { $mos == "m" } then {
	if {$idx == 6 } then {
	    set mtime [ expr $mtime + 0.001 ]
	}
	if {$idx == 5 } then {
	    set mtime [ expr $mtime + 0.01 ]
	}
	if {$idx == 4 } then {
	    set mtime [ expr $mtime + 0.1 ]
	}
	if {$idx == 3 } then {
	    set mtime [ expr $mtime + 1 ]
	}
	if {$idx == 2 } then {
	    set mtime [ expr $mtime + 10 ]
	}
	if {$idx == 1 } then {
	    set mtime [ expr $mtime + 100 ]
	}

	if { $mtime > 999.999 } then {
	    set mtime [ expr $mtime - 1000 ]
	}

	set stime [ expr $mtime * 86.4 ]

    } else {
	#
	# The stime changed
	#
	if {$idx == 6 } then {
	    set stime [ expr $stime + 1 ]
	}
	if {$idx == 5 } then {
	    set stime [ expr $stime + 10 ]
	}
	if {$idx == 4 } then {
	    set stime [ expr $stime + 60 ]
	}
	if {$idx == 3 } then {
	    set stime [ expr $stime + 600 ]
	}
	if {$idx == 2 } then {
	    set stime [ expr $stime + 3600 ]
	}
	if {$idx == 1 } then {
	    set stime [ expr $stime + 43200 ]
	}

	if { $stime >= 86400 } then {
	    set stime [ expr $stime - 86400 ]
	}

	set mtime [expr $stime / 86.4 ]
    }

    #
    # Regardless, these events always occur.
    #
    set shour [ expr $stime / 3600 ]
    set shour [ expr int( $shour ) ]
    set smins [ expr ( $stime - ( $shour * 60 * 60 ) ) / 60 ]
    set smins [ expr int( $smins ) ]
    set ssecs [ expr $stime - ( ( $shour * 60 * 60 ) + ( $smins * 60) ) ]
    set ssecs [ expr int( $ssecs ) ]
    
    if { $shour < 10 } then {
	set shour [ format "0%d" $shour ]
    }
    if { $smins < 10 } then {
	set smins [ format "0%d" $smins ]
    }
    if { $ssecs < 10 } then {
	set ssecs [ format "0%d" $ssecs ]
    }
    
    for { set i 1 } { $i < 7 } { incr i } {
	if { $i == 1 || $i == 2 } {
	    set temp [ string index $shour [ expr $i - 1 ] ]
	    .tcon.stand.s$i configure -image b$temp
	}		
	if { $i == 3 || $i == 4 } {
	    set temp [ string index $smins [ expr $i - 3 ] ]
	    .tcon.stand.s$i configure -image b$temp
	}		
	if { $i == 5 || $i == 6 } {
	    set temp [ string index $ssecs [ expr $i - 5 ] ]
	    .tcon.stand.s$i configure -image b$temp
	}
    }
    
    if { $mtime >= 100 } then { 
	set mtime [ format "%.3f" $mtime ] 
    } else {
	set mtime [ format "0%.3f" $mtime ] 
    }
    if { $mtime <  10  } then { 
	set mtime [ format "00%.3f" $mtime ] 
    }
    
    for { set i 1 } { $i < 8 } { incr i } {
	if { $i < 4 } then {
	    set temp [ string index $mtime [expr $i - 1 ] ]
	    .tcon.metric.m$i configure -image b$temp
	}
	if { $i > 4 } then {
		set temp [ string index $mtime [expr $i - 1 ] ]
	    set j [ expr $i - 1 ]
	    .tcon.metric.m$j configure -image b$temp
	}
    }
}


######################## 
#
# create all the widgets
#
########################
frame .tcon
frame .tcon.top -relief ridge -borderwidth 3
frame .tcon.metric -relief flat -borderwidth 3
frame .tcon.stand -relief flat -borderwidth 3

wm title . "Time Converter"

button .tcon.top.done -text "Done" -command { exit }
button .tcon.top.help -text "Help" -command { exec xb "$xmclib/Help_on_xmconv" }

label  .tcon.metric.label -text "Metric Time"
button .tcon.metric.m1 -image b0 -command { change m1 }
button .tcon.metric.m2 -image b0 -command { change m2 }
button .tcon.metric.m3 -image b0 -command { change m3 }
label  .tcon.metric.md -image bd
button .tcon.metric.m4 -image b0 -command { change m4 }
button .tcon.metric.m5 -image b0 -command { change m5 }
button .tcon.metric.m6 -image b0 -command { change m6 }

label  .tcon.stand.label -text "Standard Time"
button .tcon.stand.s1 -image b0 -command { change s1 } 
button .tcon.stand.s2 -image b0 -command { change s2 }
label  .tcon.stand.sc -image bc
button .tcon.stand.s3 -image b0 -command { change s3 }
button .tcon.stand.s4 -image b0 -command { change s4 }
label  .tcon.stand.sk -image bc
button .tcon.stand.s5 -image b0 -command { change s5 }
button .tcon.stand.s6 -image b0 -command { change s6 }

##########
#
# pack it!
#
##########
pack .tcon.top.done -side left
pack .tcon.top.help -side right
pack .tcon.top -fill x -side top

pack .tcon.metric.label
pack .tcon.metric.m1 -side left
pack .tcon.metric.m2 -side left
pack .tcon.metric.m3 -side left
pack .tcon.metric.md -side left
pack .tcon.metric.m4 -side left
pack .tcon.metric.m5 -side left
pack .tcon.metric.m6 -side left
pack .tcon.metric

pack .tcon.stand.label
pack .tcon.stand.s1 -side left
pack .tcon.stand.s2 -side left
pack .tcon.stand.sc -side left
pack .tcon.stand.s3 -side left
pack .tcon.stand.s4 -side left
pack .tcon.stand.sk -side left
pack .tcon.stand.s5 -side left
pack .tcon.stand.s6 -side left
pack .tcon.stand

pack .tcon
